<template>
  <div class="row">
    <div class="col"><strong>Concept</strong></div>
  </div>
  <div v-for="(ref, index) in backReferences" :key="index"
       :class="{active: current===ref.concept.id}" class="row pointer detail_bg concept_row"
       v-on:click="concept_clicked(ref.concept)">
    <div class="col ellipsis detail_bg concept_name">
      <q-icon v-if="current===ref.concept.id" name="arrow_right" size="30"></q-icon>
      {{ ref.concept_name }}
    </div>
  </div>
</template>

<script>
import {api} from "boot/axios";

export default {
  name: "ItemtypeBackref",
  data() {
    return {
      backReferences: undefined,
      current: undefined
    }
  },
  props: {
    itemtype_name: String,
    dts_name: String,
    nt_version: String
  },
  mounted() {
    if (this.itemtype_name && this.dts_name) {
      this.fetchData()
    }
  },
  watch: {
    itemtype_name: function () {
      if (this.itemtype_name && this.dts_name) {
        this.fetchData()
      }
    }
  },
  methods: {
    fetchData: function () {
      if (this.itemtype_name && this.dts_name) {
        api
          .get("/dts/" + this.dts_name + "/itemtypes/backref/" + this.itemtype_name,
            {params: {nt_version: this.nt_version}})
          .then(response => {
            this.backReferences = response.data
          })
      }
    },
    concept_clicked: function (concept) {
      this.current = concept.id
      this.$emit('conceptClicked', concept)
    }
  },
  emits: ["conceptClicked"]
}
</script>

<style scoped lang="scss">
.pointer {
  cursor: pointer;
}

.concept_row {
  border: 1px solid $blue-grey;
  padding: 2px 5px;
}

.concept_row.active {
  background-color: $list_selected_bg;
  color: white;
}

.concept_row.pointer:hover {
  background-color: $list_selected_bg;
  opacity: 0.8;
  color: white;
}

.concept_row .concept_name:hover {
  background-color: transparent;
}

.pointer .active,
.active > .detail_bg {
  background-color: transparent;
}
</style>
